/*
   acyclic.c
   San Skulrattanakulchai
   11/11/99
 */
#include "digraph.h"
#include "gen.h"
#include "random.h"

/*
   Generate a random acyclic digraph on nv vertices.  Assume each
   labelled acyclic digraph on nv vertices is equally probable.
 */

DigraphPtr acyclic(int nv)
{
  DigraphPtr Gp;
  Vertex v, w;

  makeEmptyDigraph(nv, Gp);

  for (v = 1; v < nv; v++)
    for (w = v + 1; w <= nv; w++)
      if (coinFlip())
        addEdge(v, w, Gp);

  return Gp;
}
